#define NCHIPS 4
//pins
#define P_DATA 0
#define P_CS   1
#define P_CLK  2
//registers
#define NO_OP 0x00
//register #1 to #8 are for the digits
#define DECODE_MODE 0x09
#define INTENSITY 0x0a
#define SCAN_LIMIT 0x0b
#define SHUTDOWN 0x0c
#define DISPLAY_TEST 0x0f

void max7219_send(unsigned char r,unsigned char d,int chip);
void max7219_batch(unsigned short *d);
void max7219_init();
void max7219_deinit(int clear);

